apiVersion: v1
kind: Namespace
metadata:
  name: autotest-kubectl
  labels:
   name: dev

---

apiVersion: v1
kind: Service
metadata:
  name: nginx
  namespace: autotest-kubectl
  labels:
    app: nginx
spec:
  ports:
  - port: 80
    name: web
  clusterIP: None
  selector:
    app: nginx
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: web
  namespace: autotest-kubectl
spec:
  serviceName: "nginx"
  replicas: 2
  selector:
    matchLabels:
      app: nginx
  template:
    metadata:
      labels:
        app: nginx
    spec:
      containers:
      - name: nginx
        image: k8s.gcr.io/nginx-slim:0.8
        ports:
        - containerPort: 80
          name: web
        volumeMounts:
        - name: www
          mountPath: /usr/share/nginx/html
  volumeClaimTemplates:
  - metadata:
      name: www
    spec:
      accessModes: [ "ReadWriteMany" ]    #指定pv的读写策略
      storageClassName: "local-storage"    #指定pv的存储类型
      resources:
        requests:
          storage: 1Gi    #指定pv的存储大小

---

kind: StorageClass
apiVersion: storage.k8s.io/v1
metadata:
  name: local-storage
provisioner: kubernetes.io/no-provisioner
volumeBindingMode: WaitForFirstConsumer

---

apiVersion: v1
kind: PersistentVolumeClaim
metadata:
  name: local-storage
  namespace: autotest-kubectl #指定pvc属于哪个命名空间
spec:
  storageClassName: local-storage
  accessModes:
  - ReadWriteMany  #读写模式
  resources:
    requests:
      storage: 500Mi
